package cn.dankal.share;

/**
 * DclSingletonTest
 * <br/>
 *
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2020/12/29
 * @copyright 蛋壳创意科技 - www.dankal.cn
 */
public class DclSingletonTest {
    public static void main(String[] args) {
        SingletonInstance singletonInstance = SingletonInstance.getInstance();
    }
}

class SingletonInstance {

    private static volatile SingletonInstance singletonInstance;

    private SingletonInstance() {

    }

    public static SingletonInstance getInstance() {
        if (null == singletonInstance) {
            synchronized (SingletonInstance.class) {
                if (null == singletonInstance) {
                    singletonInstance = new SingletonInstance();
                }
            }
        }
        return singletonInstance;
    }
}
